package com.ejie.ab39a.control;

import com.ejie.ab39a.service.MunicipioService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import com.ejie.ab39a.model.Municipio;

/**
 * MunicipioController.
 * 
 *  
 */

@Controller
@RequestMapping(value = "/municipio")

public class MunicipioController {

	private static final Logger logger = LoggerFactory.getLogger(MunicipioController.class);

	@Autowired
	private MunicipioService municipioService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idMunicipio
	 *            String id municipio
	 * @param idProvincia
	 *            String id provincia
	 * @param descOf
	 *            String descripcion
	 * @return Municipio Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idMunicipio}/{idProvincia}/{descOf}", method = RequestMethod.GET)
	public @ResponseBody Municipio get(@PathVariable String idMunicipio, @PathVariable String idProvincia,
			@PathVariable String descOf) {
		Municipio municipio = new Municipio();
		municipio.setIdMunicipio(idMunicipio);
		municipio.setIdProvincia(idProvincia);
		municipio.setDescOf(descOf);
		municipio = this.municipioService.find(municipio);
		MunicipioController.logger.info("[GET - findBy_PK] : Obtener Municipio por PK");
		return municipio;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterMunicipio
	 *            Municipio Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @param codTH
	 *            String codigo territorio historico
	 * @return List<Municipio> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(value = "getAllMunicipio", method = RequestMethod.GET)
	public @ResponseBody List<Municipio> getAll(@ModelAttribute Municipio filterMunicipio,
			@RequestParam(value = "codth", required = false) String codTH) {
		MunicipioController.logger.info("[GET - find_ALL] : Obtener Municipio por filtro");
		filterMunicipio.setIdProvincia(codTH);
		return this.municipioService.findAll(filterMunicipio, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param municipio
	 *            Municipio Bean que contiene la informacion a modificar.
	 * @return Municipio Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody Municipio edit(@RequestBody Municipio municipio) {
		Municipio municipioAux = this.municipioService.update(municipio);
		MunicipioController.logger.info("[PUT] : Municipio actualizado correctamente");
		return municipioAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param municipio
	 *            Municipio Bean que contiene la informacion con la que se va a
	 *            crear el nuevo registro.
	 * @return Municipio Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody Municipio add(@RequestBody Municipio municipio) {
		Municipio municipioAux = this.municipioService.add(municipio);
		MunicipioController.logger.info("[POST] : Municipio insertado correctamente");
		return municipioAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idMunicipio
	 *            String id municipio
	 * @param idProvincia
	 *            String id provincia
	 * @param descOf
	 *            String Identificador del objeto que se desea eliminar.
	 * @return Municipio Bean eliminado.
	 */
	@RequestMapping(value = "/{idMunicipio}/{idProvincia}/{descOf}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Municipio remove(@PathVariable String idMunicipio, @PathVariable String idProvincia,
			@PathVariable String descOf) {
		Municipio municipio = new Municipio();
		municipio.setIdMunicipio(idMunicipio);
		municipio.setIdProvincia(idProvincia);
		municipio.setDescOf(descOf);
		this.municipioService.remove(municipio);
		MunicipioController.logger.info("[DELETE] : Municipio borrado correctamente");
		return municipio;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit() {
		MunicipioController.logger.info("[GET - View] : municipio");
		return "municipio";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterMunicipio
	 *            Municipio Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<Municipio> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<Municipio> filter(
			@RequestJsonBody(param = "filter") Municipio filterMunicipio,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		MunicipioController.logger.info("[POST - filter] : Obtener Municipios");
		return this.municipioService.filter(filterMunicipio, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterMunicipio
	 *            Municipio Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") Municipio filterMunicipio,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		MunicipioController.logger.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples Municipios");
		this.municipioService.removeMultiple(filterMunicipio, jqGridRequestDto, false);
		MunicipioController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}
}
